using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;

namespace Selections
{
    public partial class Form1 : Form
    {
        ImageList imageList = new ImageList();
        public Form1()
        {
            InitializeComponent();

            this.gridControl1.Cols.Hidden[0] = true;
            this.gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(0, 1, 0, 3));
            GridStyleInfo style = new GridStyleInfo();
            style.CellType = GridCellTypeName.Image;
            style.Enabled = false;

            this.gridControl1.Model.ChangeCells(GridRangeInfo.Cols(1, 2), style);

            this.imageList.Images.Add(SystemIcons.WinLogo.ToBitmap());
            this.imageList.Images.Add(SystemIcons.Asterisk.ToBitmap());

            this.gridControl1.ColStyles[1].ImageList = this.imageList;
            this.gridControl1.ColStyles[2].ImageList = this.imageList;

            this.gridControl1.ColStyles[1].ImageIndex = 0;
            this.gridControl1.ColStyles[2].ImageIndex = 1;

            
            style.CellType = GridCellTypeName.CheckBox;
            style.Enabled = true;

            this.gridControl1.Model.ChangeCells(GridRangeInfo.Cols(5, 12), style);
            
            style.CellType = GridCellTypeName.Static;
            this.gridControl1.Model.ChangeCells(GridRangeInfo.Cols(3, 4), style);

            this.gridControl1.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.HideAlways;

            for (int i = 1; i <= 5; i++)
            {
                this.gridControl1[i, 3].Text = string.Format("Name{0}", i);
                this.gridControl1[i, 4].Text = string.Format("Device{0}", i);
            }

            this.gridControl1.ColWidths.SetRange(1,2, 25);
            this.gridControl1.ColWidths.SetRange(5, 12, 15);


            this.gridControl1.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(gridControl1_PrepareViewStyleInfo);
            this.gridControl1.CurrentCellChanged += new EventHandler(gridControl1_CurrentCellChanged);

            this.gridControl1.CurrentCellMoving += new GridCurrentCellMovingEventHandler(gridControl1_CurrentCellMoving);
            this.gridControl1.RefreshCurrentCellBehavior = GridRefreshCurrentCellBehavior.RefreshRow;
            this.gridControl1.SelectionChanged += new GridSelectionChangedEventHandler(gridControl1_SelectionChanged);

        }

        void gridControl1_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
        {
            GridRangeInfo range = e.Range.IntersectRange(GridRangeInfo.Cols(3,4));
            if(!range.IsEmpty)
            {
                for (int i = range.Top; i <= range.Bottom; i++)
                    for (int j = range.Left; j <= range.Right; j++)
                        this.gridControl1.Selections.Add(GridRangeInfo.Cell(i, 2));
                this.gridControl1.InvalidateRange(GridRangeInfo.Col(2));
            }
        }

        void gridControl1_CurrentCellMoving(object sender, GridCurrentCellMovingEventArgs e)
        {
            this.gridControl1.RefreshRange(GridRangeInfo.Row(e.RowIndex));
        }

        void gridControl1_CurrentCellChanged(object sender, EventArgs e)
        {
            GridCurrentCell cc = this.gridControl1.CurrentCell;
            if (cc.ColIndex > 4)
                this.gridControl1.RefreshRange(GridRangeInfo.Row(cc.RowIndex));
        }


        void gridControl1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
        {
            GridCurrentCell cc = this.gridControl1.CurrentCell;
            if ((e.ColIndex == 2 || e.ColIndex == cc.ColIndex) && e.RowIndex > 0 && cc.ColIndex < 5
                && e.RowIndex == cc.RowIndex )

                e.Style.BackColor = Color.FromArgb(65,Color.FromArgb( 64, 49, 106, 197));

            if (e.RowIndex > 0 && e.ColIndex > 4 && !(e.ColIndex == cc.ColIndex && e.RowIndex == cc.RowIndex))
            {
                bool flag = false;
                GridData data = this.gridControl1.Data;
                for (int i = 5; i <= 12; i++)
                {
                    GridStyleInfo style = new GridStyleInfo(data[e.RowIndex, i]);
                    if (style.CellValue.ToString() == "1")
                    {
                        flag = true;
                        break;
                    }
                }
                if(flag)
                    e.Style.BackColor = Color.FromArgb(65, Color.FromArgb(64, 49, 106, 197));

            }

        }
    }
}